#include<bits/stdc++.h>
using namespace std;
const long long MAXN=1000007;
long long n;
long long mas[MAXN],par[MAXN],teg[MAXN];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    mas[0]=0;
    par[0]=0;
    teg[0]=0;
    cin>>n;
    long long otg=0;
    for (int q12=1;q12<=n;q12++)
    {
        long long p,m;
        cin>>p>>m;
        if (m>0)
        {
            mas[q12]=m;
            par[q12]=p;
        }
        else
        {
            mas[q12]=mas[par[p]];
            par[q12]=par[par[p]];
        }
        teg[q12]=teg[par[q12]]+mas[q12];
        otg+=teg[q12];
        //cout<<mas[q12]<<" "<<par[q12]<<"\n";
    }
    cout<<otg<<"\n";
}
